<!DOCTYPE html>
<html lang="en"
      xmlns:layout="http://www.ultraq.net.nz/thymeleaf/layout"
      xmlns:th="http://www.thymeleaf.org"
      xmlns:sec="http://www.thymeleaf.org/extras/spring-security"
      layout:decorate="~{layout}">
<head>
    <meta charset="UTF-8">
    <title>Beginning Balance</title>
</head>
<body>
<main layout:fragment="main" class="container-xxl bd-gutter mt-3 my-md-4 bd-layout">
    <div th:include="sidebar/sidebar_setting::sidebar_setting" th:remove="tag">
        sidebar
    </div>

    <main class="bd-main-xxl">
        <div class="row">
            <div class="col-md-12">
                <div class="card shadow-sm">
                    <div class="card-header">
                        <h5>Saldo awal per-akun</h5>
                    </div>
                    <div class="card-body">
                        <form th:action="@{/beginningBalance/save}" method="post" th:object="${accountBalance}">
                            <div class="form-group mb-3">
                                <label>Akun</label>
                                <input type="hidden" th:if="*{id != null}" name="id" th:field="*{id}">
                                <select class="form-select" th:if="*{id == null}" name="account" id="select" required>
                                    <option value="">-- Pilih Salah Satu --</option>
                                    <option th:each="data, row:${account}"
                                            th:value="${data.id}"
                                            th:text="${data.code + ' - ' + data.name}"
                                            th:field="*{account}"></option>
                                </select>
                                <input type="hidden" class="form-control" th:if="*{id != null}" name="account" th:field="*{account}" readonly>
                                <input type="text" class="form-control" th:if="*{id != null}" th:field="*{account.name}" readonly>
                            </div>
                            <div class="form-group mb-3">
                                <label>Saldo Awal</label>
                                <input type="text" id="numberInput" class="form-control" required th:value="*{#numbers.formatDecimal(accountBalance, 0, 'POINT', 2, 'COMMA')}" name="accountBalance">
                            </div>
                            <div class="form-group mb-3">
                                <label>Tahun Mulai</label>
                                <select class="form-select" th:if="*{id == null}" name="year" id="tahun" required>
                                    <option value=""></option>
                                    <option th:each="data, row:${year}"
                                            th:value="${data.year}"
                                            th:text="${data.year}"
                                            th:field="*{year}"></option>
                                </select>
                                <input type="text" class="form-control" th:if="*{id != null}" name="year" th:field="*{year}" readonly>
                            </div>
                            <div class="form-group mb-3" th:if="*{id != null}">
                                <label>Institut</label>
                                <select name="institut" th:field="*{institut}" class="form-control">
                                    <option value=""> -- Pilih --</option>
                                    <option th:each="data, row:${accountInstitut}"
                                            th:text="${data.institut.namaInstitut}"
                                            th:value="${data.institut.id}"></option>
                                </select>
                            </div>
                            <div class="form-group mb-3"  th:if="*{id == null}">
                                <label>Institut</label>
                                <select name="institut" id="institut-select" th:field="*{institut}" class="form-select">
                                    <option value=""> -- Pilih --</option>
<!--                                    <option th:each="data, row:${accountInstitut}"-->
<!--                                            th:text="${data.institut.namaInstitut}"-->
<!--                                            th:value="${data.institut.id}"></option>-->
                                </select>
                            </div>
                            <div class="form-group mb-3">
                                <button type="submit" class="btn btn-primary">Simpan</button>
                                <a th:href="@{/beginningBalance}" class="btn btn-danger">Kembali</a>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </main>
</main>
<div layout:fragment="footer" class="script">
    <script>
        document.getElementById('numberInput').addEventListener('input', function (e) {
            let value = e.target.value;

            // Menghapus karakter yang bukan angka atau koma
            value = value.replace(/[^\d,]/g, '');

            // Jika ada lebih dari satu koma, ambil hanya bagian sebelum koma pertama
            const parts = value.split(',');
            value = parts[0].replace(/\B(?=(\d{3})+(?!\d))/g, '.');
            if (parts.length > 1) {
                value += ',' + parts[1];
            }

            // Mengupdate nilai input
            e.target.value = value;
        });

        $('#select').select2({
            theme: 'bootstrap-5',
            placeholder: '- Select Account -'
        });

        $('#select').on('select2:select', function (e) {
            const accountId = e.target.value;
            console.log(accountId);

            // Kosongkan opsi pada select institut
            const institutSelect = document.getElementById("institut-select");
            institutSelect.innerHTML = '<option value=""> -- Pilih --</option>';

            if (accountId) {
                console.log(`Fetching data for account ID: ${accountId}`);
                fetch(`/api/accountInstitut/${accountId}`)
                    .then((response) => {
                        if (!response.ok) {
                            throw new Error(`Network error: ${response.status}`);
                        }
                        return response.json();
                    })
                    .then((data) => {
                        if (Array.isArray(data)) {
                            data.forEach((item) => {
                                const option = document.createElement("option");
                                option.value = item.institut.id;
                                option.textContent = item.institut.namaInstitut;
                                institutSelect.appendChild(option);
                            });
                        } else {
                            console.error("Unexpected data format", data);
                        }
                    })
                    .catch((error) => {
                        console.error("Fetch error:", error);
                    });
            }
        });



    </script>
</div>
</body>
</html>
